<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>cs-concepts</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="core-concepts-of-computer-programming">
      Core Concepts of Computer Programming
    </h1>
    <p>TOC</p>
    <ol type="1">
      <li><a href="#intro">Intro</a></li>
      <li>
        <a href="#input-and-output">Input / Output</a>
        <ol type="1">
          <li><a href="#hello-world-program">Hello World Program</a></li>
        </ol>
      </li>
      <li>
        <a href="#variables-and-data-types">Variables &amp; Data Types</a>
        <ol type="1">
          <li>
            <a href="#sample-program-for-variables-and-data-types"
              >Sample Program for Variables and Data Types</a
            >
          </li>
        </ol>
      </li>
      <li>
        <a href="#operators">Operators</a>
        <ol type="1">
          <li>
            <a href="#assignment-operators-sample-program"
              >Assignment Operators Sample Program</a
            >
          </li>
          <li>
            <a href="#arithmetic-operators-sample-program"
              >Arithmetic Operators Sample Program</a
            >
          </li>
          <li>
            <a href="#comparison-operators-sample-program"
              >Comparison Operators Sample Program</a
            >
          </li>
        </ol>
      </li>
      <li>
        <a href="#conditionals">Conditionals</a>
        <ol type="1">
          <li>
            <a href="#sample-program-using-if">Sample Program Using IF</a>
          </li>
          <li>
            <a href="#sample-program-using-if-else"
              >Sample Program Using IF/ELSE</a
            >
          </li>
        </ol>
      </li>
      <li>
        <a href="#functions">Functions</a>
        <ol type="1">
          <li>
            <a href="#sample-program-creating-and-using-functions"
              >Sample Program Creating And Using Functions</a
            >
          </li>
        </ol>
      </li>
    </ol>
    <h2 id="intro">Intro</h2>
    <p>
      Of all the inventions in the field of electronics like the radio and
      telephone, the programmable computer was the most significant one. It
      changed the world forever.
    </p>
    <p>
      If ever a certain device can be programmed the way we want it to behave,
      then we can simply instruct it to do things for us. That’s very practical,
      isn’t it?
    </p>
    <p>
      After the programmable computers, the next big question was how humans
      would program these computers. They began developing programming languages
      and the 1970s was a very remarkable period: the C language was invented.
    </p>
    <p>
      After the success, the great potential was unleashed and we are now seeing
      the things a programmable computer can do: the era of information,
      real-time data, almost realistic 3D games, artificial intelligence, etc.
    </p>
    <p>
      Learning computer science now is a very sophisticated one unlike it was in
      the past: there are too many fields even in software development alone.
    </p>
    <p>
      And if you are a beginner, you might be discouraged from all the things
      you need to learn but don’t worry:
      <strong>you don’t need to learn them all</strong>. What you need to learn
      first is the understanding how computers work and the fundamentals of
      computer programming that all computer programming languages have in
      common.
    </p>
    <p>
      And since almost every programming language nowadays directly and
      indirectly inherits concepts from the C language, we’ll be using it to
      demonstrate the core concepts of programming.
    </p>
    <p>
      <em
        >Take note: we don’t want to discuss every detail of the code in terms
        of the C language, rather we just want to get the core concepts of
        computer programming that are common in different programming
        languages.</em
      >
    </p>
    <h2 id="input-and-output">Input And Output</h2>
    <p>
      As was mentioned, a programmable computer is very important but the way
      you interact with the computer is through input and output: you as the
      user will have an input, the computer will process it (the way it is
      processed is programmed also), then the computer will output something.
      The very first demonstration is the “Hello World” program. The programmer
      will tell the computer to simply display the message on the screen.
    </p>
    <p>
      But of course, complex programs are not as straightforward as that.
      Typical programs like binary to human language (and vice versa) takes a
      lot of processing, an operating system to recognize computer applications,
      a business collaborative tool with a lot of features to manage data, a 3D
      game that is almost realistic, an Artificial Intelligence program that can
      simulate humans in the virtual world!
    </p>
    <p>
      But of all the things programmers can do, the computer only processes
      input as binary data (0s and 1s) and it should not be interpreted
      literally. It’s just a representation of something a computer can
      recognize: absence or presence of electric pulse. Compare this with any
      drawing that can be accomplished just by simply using a dot-and-no-dot
      pattern! It’s the same thing for the computer.
    </p>
    <h3 id="hello-world-program">Hello World Program</h3>
    <pre><code>#include &lt;stdio.h&gt;

int main() {

    printf(&quot;Hello World!\n&quot;);
    printf(&quot;Life is a blessing!\n&quot;);

    return 0;

}</code></pre>
    <p>
      In this small program, the <code>#include</code> tells the computer to
      include a certain source which is needed because it contains the
      predefined command <code>printf</code>. <code>printf</code> simply tells
      the computer to display the text provided by the programmer.
    </p>
    <p>
      As simple as that, you have now the complete idea of what a programmable
      computer is all about. It’s you telling the computer to do things it can
      handle in terms of binary data.
    </p>
    <h2 id="variables-and-data-types">Variables And Data Types</h2>
    <p>
      In computer programming, a <strong>variable</strong> is just like a
      container to store digital data. A <strong>data type</strong> is the way
      you tell the computer how that data will be interpreted. Should the
      computer interpret that as letters? or numbers? or words? or simply raw
      binary data? The computer does not know that, you must tell it exactly.
    </p>
    <p>
      In computer programming, both these things will enable you to store data
      and tell the computer what kind of data it is. When you store, you want to
      retrieve it later as per needed. Remember also, computer’s memory is
      different from storage. Think of it as the short-term memory and the
      storage (the hard disk) as the long-term memory. But during the runtime of
      a program you are developing, you refer to memory as <code>storage</code>.
      The computer’s memory has the full access to the CPU while the disk does
      not have that access. In order to read contents from the hard disk, a
      request should be made. Hence, in programming you are using the memory
      first not the disk. There is the current development to combine the two
      but is still on-going.
    </p>
    <p>
      Take note, the details of memory, hard disk and CPU are quite complex but
      the mentioned details above will serve as the starting point for full
      comprehension.
    </p>
    <h3 id="sample-program-for-variables-and-data-types">
      Sample Program for Variables and Data Types
    </h3>
    <pre><code>#include &lt;stdio.h&gt;

int main() {

    int i = 1;
    char myletter[] = &quot;myletter&quot;;
    float x = 1.23;

    printf(&quot;int i: %d\n&quot;, i);
    printf(&quot;char myletter[]: %s\n&quot;, myletter);
    printf(&quot;float x: %f\n&quot;, x);

    return 0;
}</code></pre>
    <p>
      In this simple program, we declare and assign 3 variables with different
      data types:
    </p>
    <ol type="1">
      <li>variable <code>i</code> that contains 1 numeric value</li>
      <li>
        variable character <code>myletter[]</code> that contains letters
        <code>myletter</code>
      </li>
      <li>variable <code>x</code> that contains 1.23 value</li>
    </ol>
    <p>
      After that, the program is telling the computer to display these values.
    </p>
    <h2 id="operators">Operators</h2>
    <p>
      In programming just like in mathematics, there are operators and the most
      common in computer programming are assignment, arithmetic and comparison
      operators.
    </p>
    <h3 id="assignment-operators-sample-program">
      Assignment Operators Sample Program
    </h3>
    <pre><code>#include &lt;stdio.h&gt;

int main() {
    int c;

    c = 10;
    printf(&quot;c = %d\n&quot;, c);
    c = 15;
    printf(&quot;c = %d\n&quot;, c);
    c = 3;
    printf(&quot;c = %d\n&quot;, c);

    return 0;
}</code></pre>
    <p>
      The most common assignment operator is <code>=</code> and it should not be
      confused with the double <code>==</code> comparison operator.
    </p>
    <p>
      This time, it is simply assigning a value to a variable. The result is:
    </p>
    <pre><code>c = 10
c = 15
c = 3</code></pre>
    <p>
      Variable <code>c</code> contains a value at a specific time. It was
      changed in the program three times.
    </p>
    <h3 id="arithmetic-operators-sample-program">
      Arithmetic Operators Sample Program
    </h3>
    <pre><code>#include &lt;stdio.h&gt;

int main() {
    int a = 10;
    int b = 5;
    int result;

    printf(&quot;where a = %d &amp; b = %d \n&quot;, a, b);

    result = a + b;
    printf(&quot;a+b = %d \n&quot;, result);
    result = a - b;
    printf(&quot;a-b = %d \n&quot;, result);
    result = a * b;
    printf(&quot;a*b = %d \n&quot;, result);
    result = a / b;
    printf(&quot;a/b = %d \n&quot;, result);

    return 0;
}</code></pre>
    <p>
      Since these are arithmetic operators, they will do the basic arithmetic
      operations.
    </p>
    <p>The result is:</p>
    <pre><code>where a = 10 &amp; b = 5
a+b = 15
a-b = 5
a*b = 50
a/b = 2</code></pre>
    <h3 id="comparison-operators-sample-program">
      Comparison Operators Sample Program
    </h3>
    <pre><code>#include &lt;stdio.h&gt;

int main() {
    int a = 10, b = 10, c = 20;

    printf(&quot;%d == %d is %d \n&quot;, a, b, a == b);
    printf(&quot;%d == %d is %d \n&quot;, a, c, a == c);
    printf(&quot;%d &gt; %d is %d \n&quot;, a, b, a &gt; b);

    return 0;
}</code></pre>
    <p>
      Since these are comparison operators, they are comparing the left and
      right side values.
    </p>
    <p>The result is:</p>
    <pre><code>10 == 10 is 1
10 == 20 is 0
10 &gt; 10 is 0</code></pre>
    <p>The result is either 0 or 1 and remember, 0 is FALSE and 1 is TRUE.</p>
    <h2 id="conditionals">Conditionals</h2>
    <p>
      In a comprehensive program, the computer must decide based on the
      condition/s given. Of course, the computer cannot do that alone, you must
      instruct it exactly. The most common is the IF statement with the extended
      IF/ELSE.
    </p>
    <h3 id="sample-program-using-if">Sample Program Using IF</h3>
    <pre><code>#include &lt;stdio.h&gt;

int main() {
    int i = 10;

    if (i == 10) printf(&quot;Expected value is the same as variable i, so the result is TRUE. \n&quot;);

    return 0;
}</code></pre>
    <p>
      In a single IF statement, the programmer wants to test, expect or verify
      something, such as this program. The programmer is expecting that
      <code>i</code> variable has the value 10, and variable <code>i</code> has
      the same value, so the statement
      <code
        >Expected value is the same as variable i, so the result is TRUE.</code
      >
      will be printed. If the expected value is not the same as the value of the
      variable, the statement will not be printed.
    </p>
    <p>
      Sometimes, just an IF will not be sufficient, particularly when you want
      to catch the FALSE result or create a nested IF-ELSE. So, you want to
      extend it and catch the FALSE result.
    </p>
    <h3 id="sample-program-using-if-else">Sample Program Using IF ELSE</h3>
    <pre><code>#include &lt;stdio.h&gt;

int main() {
    int i = 10;

    if (i == 11) {
        printf(&quot;Expected value is the same as variable i, so the result is TRUE. \n&quot;);
    } else {
        printf(&quot;Expected value is not the same as variable i, so the result is FALSE. \n&quot;);
    }
    return 0;
}</code></pre>
    <p>
      Not only the statement in the ELSE branch will be printed, you can do a
      lot of things just like correct an error, go to a certain part of a
      program, etc. That’s the power of catching the FALSE result.
    </p>
    <h2 id="loops">Loops</h2>
    <p>
      There are commands or portions of your program to be repeated several
      times. Loops are there to do that. Now, there are simple loops and loops
      based on a given condition, much like a repeated IF statement. Simple
      loops are like repeat 10 times or repeat forever. Conditional loops are
      loops with specific conditions other than simple iteration just like in
      robot programming: repeat until color red, repeat until the distance is
      less than 50mm, etc.
    </p>
    <p>
      The most common that we see in computer programming: the
      <code>for</code> loop, <code>while</code> loop and
      <code>do-while</code> loop.
    </p>
    <h3 id="sample-program-using-loops">Sample Program Using Loops</h3>
    <pre><code>#include &lt;stdio.h&gt;

int main() {

    int n = 11;

    int i;
    int x[n];
    printf(&quot;the `for` loop: \n&quot;);
    for (i = 1; i &lt; n; i++) {

        printf(&quot;iteration: %d | Hello World. \n&quot;, i);
    }

    int y = 0;
    printf(&quot;------ \n&quot;);
    printf(&quot;the `while` loop: \n&quot;);
    while (y &lt; 10) {
        y += 1;
        printf(&quot;iteration: %d | Hello World. \n&quot;, y);
    }

    y = 0;

    printf(&quot;------ \n&quot;);
    printf(&quot;the `do while` loop: \n&quot;);

    do {
        y += 1;
        printf(&quot;iteration: %d | Hello World. \n&quot;, y);
    }
    while (y &lt; 10);

    return 0;

}</code></pre>
    <p>the result:</p>
    <pre><code>the `for` loop:
iteration: 1 | Hello World.
iteration: 2 | Hello World.
iteration: 3 | Hello World.
iteration: 4 | Hello World.
iteration: 5 | Hello World.
iteration: 6 | Hello World.
iteration: 7 | Hello World.
iteration: 8 | Hello World.
iteration: 9 | Hello World.
iteration: 10 | Hello World.
------
the `while` loop:
iteration: 1 | Hello World.
iteration: 2 | Hello World.
iteration: 3 | Hello World.
iteration: 4 | Hello World.
iteration: 5 | Hello World.
iteration: 6 | Hello World.
iteration: 7 | Hello World.
iteration: 8 | Hello World.
iteration: 9 | Hello World.
iteration: 10 | Hello World.
------
the `do while` loop:
iteration: 1 | Hello World.
iteration: 2 | Hello World.
iteration: 3 | Hello World.
iteration: 4 | Hello World.
iteration: 5 | Hello World.
iteration: 6 | Hello World.
iteration: 7 | Hello World.
iteration: 8 | Hello World.
iteration: 9 | Hello World.
iteration: 10 | Hello World.</code></pre>
    <p>
      As you can see here, it’s just printing the Hello World ten times, whether
      it’s <code>for</code> loop, <code>while</code> loop or
      <code>do-while</code> loop.
    </p>
    <h2 id="functions">Functions</h2>
    <p>
      A function is a group of statements (commands) that together perform a
      task. There are built-in functions and functions that a programmer will
      create according to his/her needs.
    </p>
    <h3 id="sample-program-creating-and-using-functions">
      Sample Program Creating And Using Functions
    </h3>
    <pre><code>#include &lt;stdio.h&gt;

void myFunction() {
    printf(&quot;Hello World.\n&quot;);
    printf(&quot;Life is beautiful.\n&quot;);
    printf(&quot;Cherish every single moment.\n&quot;);
}

int main() {

    myFunction();

    return 0;
}</code></pre>
    <p>
      The function <code>printFunctionTest()</code> is created by declaring
      <code>void</code> first. Other functions will return values but for the
      sake of simplicity we create a void <code>function</code>. A
      <code>void</code> function will simply execute the commands contained in
      it, nothing else.
    </p>
    <p>
      Then inside the main function, you simply invoke it by its name. And all
      the commands inside that function will be executed line by line.
    </p>
    <p>
      Why use functions? Imagine if there is none. Complex programs are usually
      composed of thousands of lines of code up to million, without any
      grouping, that will be very hard to handle.
    </p>
    <p>
      If a function is generic and can be used for other projects, you can
      simply separate it for distribution. So your code is now reusable.
    </p>
  </body>
</html>
